unit UntMisc;

interface

uses
  Classes;

procedure WriteBool(Const aMs:TStream;const aValue:boolean);
procedure WriteByte(Const aMs:TStream;const aValue:byte);
procedure WriteInt(Const aMs:TStream;const aValue:Integer);
procedure WriteString(Const aMs:TStream;const aValue:String);
function ReadBool(Const aMs:TStream):boolean;
function ReadByte(Const aMs:TStream):byte;
function ReadInt(Const aMs:TStream):Integer;
function ReadString(Const aMs:TStream):String;

implementation

uses SysUtils;

procedure WriteBool(Const aMs:TStream;const aValue:boolean);
begin
  if avalue then
    WriteByte(aMs,1)
  else
    WriteByte(aMs,0);
end;

procedure WriteByte(Const aMs:TStream;const aValue:byte);
begin
  aMs.Write(aValue,SizeOf(aValue));
end;

procedure WriteInt(Const aMs:TStream;const aValue:Integer);
begin
  aMs.Write(aValue,SizeOf(aValue));
end;

function ReadByte(Const aMs:TStream):byte;
begin
  ams.Read(result,SizeOf(Result));
end;

function ReadInt(Const aMs:TStream):Integer;
begin
  ams.Read(result,SizeOf(Result));
end;

procedure WriteString(Const aMs:TStream;const aValue:String);
var
  l:integer;
begin
  l:=length(aValue);
  writeInt(aMs,l);
  ams.Write(aValue[1],l);
end;

function ReadBool(Const aMs:TStream):boolean;
begin
  result:=(ReadByte(aMs)=1);
end;

function ReadString(Const aMs:TStream):String;
var
  i:Integer;
begin
  i:=ReadInt(aMs);
  SetLength(result,i);
  ams.Read(result[1],i);
end;

end.
